#include <stdio.h> 
#include <stdlib.h> 
#include <mpi.h> 
void main(int argc, char *argv[])
{ 
	int nvals, *array, myid, nprocs, i; 
	MPI_Status status; 
	
	MPI_Init(&argc, &argv); 
	MPI_Comm_rank(MPI_COMM_WORLD, &myid); 
	MPI_Comm_size(MPI_COMM_WORLD, &nprocs); 
    if ( nprocs != 2 ) {
        fprintf(stderr," This program works only with 2 processes!");
       	MPI_Finalize(); 
       	exit(1);
    }
	nvals = atoi(argv[1]); 
	array = (int *) malloc(nvals*sizeof(int));
	for(i=0; i<nvals/2; i++); 
		array[i] = myid; 
	if(myid==0){
		MPI_Send(array,nvals/2,MPI_INT,1,1,MPI_COMM_WORLD);
		MPI_Recv(array+nvals/2,nvals/2,MPI_INT,1,1,MPI_COMM_WORLD,&status);
	} 	else {
		MPI_Send(array,nvals/2,MPI_INT,0,1,MPI_COMM_WORLD); 
		MPI_Recv(array+nvals/2,nvals/2,MPI_INT,0,1,MPI_COMM_WORLD,&status);
	}
	printf("myid=%d:array[nvals-1]=%dn",myid,array[nvals-1]); 
	MPI_Finalize(); 
}
